package fmi19.block1;

import java.util.Collection;

import org.jgrapht.graph.DefaultDirectedGraph;
import org.jgrapht.graph.DefaultEdge;
import org.sat4j.core.Vec;
import org.sat4j.core.VecInt;
import org.sat4j.specs.IVec;
import org.sat4j.specs.IVecInt;

import fmi19.block1.Coloring.Color;

/**
 * Defines the Reductions
 * 
 */
public class SatEncodings {
	/**
	 * Gets a graph as input and generates a (representation of a) propositional formula that is satisfiable iff the graph has a valid coloring. 
	 *  
	 * @param graph
	 * @return cnf formula
	 */
	public IVec<IVecInt> fourColoring(DefaultDirectedGraph<Integer, DefaultEdge> graph) {
		// TODO		
	}
	
	/**
	 * Gets a graph and a set of vertices as input and generates a (representation of a) propositional formula that is satisfiable iff the graph has a valid coloring coloring all the vertices in the set red.
	 * @param graph
	 * @param redVertices
	 * @return
	 */
	public IVec<IVecInt> fourColoring(DefaultDirectedGraph<Integer, DefaultEdge> graph, Collection<Integer> redVertices) {
		// TODO		
	}

	
	/**
	 * Generates an CNF that for a given instance graph and valid coloring test whether the coloring is maximal w.r.t. red colored vertices.
	 * The formula is unsatisfiable iff the coloring is maximal, and the models of the formula
	 * correspond to valid colorings whose red colored vertices are a strict superset of the vertices colored red by the given coloring.  
	 * 
	 * @param graph
	 * @param target
	 * @param coloring
	 * @return CNF formula
	 */
	public IVec<IVecInt> maxColoring(DefaultDirectedGraph<Integer, DefaultEdge> graph, Coloring coloring) {
		// TODO
	}
		
	
	/**
	 * Takes a model of the formula generated via one of the other methods and an coloring. 
	 * Updates the coloring to a coloring corresponding to the model.
	 * 
	 * @param coloring
	 * @param model
	 */
	public void getColoringFromModel(Coloring coloring, int[] model) {
		// TODO
	}
}
